#
# DNS Balance
#
# 
#
# By: YOKOTA Hiroshi <yokota@netlab.is.tsukuba.ac.jp>

# $Id: util.rb,v 1.5 2002/10/05 16:17:12 elca Exp $

# DNS ѥå RR ̾ʹ֤ɤߤ䤹Ѵ
def dnsstr_to_str(dnsstr)
  arr = []
  c = 0

  while TRUE
    if dnsstr[c] == 0
      break
    end
    arr.push(dnsstr[c+1, dnsstr[c]])
    c += dnsstr[c]+1
  end

  return arr.join(".")
end

def str_to_dnsstr(str)
  domainstr = ""
  str.split(".").each {
    |i|
    domainstr += i.length.chr + i
  }
  domainstr += "\0"

  return domainstr
end


# IP ɥ쥹ɽ餽˸ä4ХȤʸ
#
# ex) "127.0.0.1" => "\x7f\x0\x0\x1"
def str_to_ipstr(str)
  arr = str.split(".").collect{|i| i.to_i}

  return arr.pack("CCCC")
end

def ipstr_to_str(ipstr)
  return ipstr.unpack("CCCC").collect{|i| i.to_s}.join(".")
end

def ipstr_array_to_str(arr)
  return arr.collect{|i| ipstr_to_str(i)}.join(" ")
end

# ipstr Фƥӥåȥޥ򤫤
def ipstr_mask(ipstr, mask)
  n = ipstr.unpack("N")[0] & (0xffffffff << (32-mask))
  return [n].pack("N")
end

# IP ɥ쥹 /32  /1 ޤǤΥޥ򤫤ɥ쥹ΥꥹȤ֤
def ip_masklist(str)
  ipstr = str_to_ipstr(str)

  netaddrs = []
  (0..31).each {
    |i|
    mask = 32-i

    netaddrs << (ipstr_to_str(ipstr_mask(ipstr, mask)) + "/" + mask.to_s)
  }

  return netaddrs
end


#
def min(a, b)
  return (if a < b then a else b end)
end

def max(a, b)
  return (if a < b then b else a end)
end

# ¤Ѥ
def array_randomize(arr)
  return []  if arr.size == 0
  return arr if arr.size == 1

  ret = []
  h = {}

  for i in 0..(arr.size-1)
    p = rand()
    h[p] = i
  end

  hh = h.sort
  for i in hh
    ret += arr[i[1],1]
  end

  return ret
end

# end
